fanotify09 test case 1 in LTP failed with first group got more than 2 events

Bug #1804594 reported by Po-Hsu Lin on 2018-11-22
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
ubuntu-kernel-tests
Undecided
Kleber Sacilotto de Souza
linux (Ubuntu)
Undecided
Unassigned
Xenial
Undecided
Kleber Sacilotto de Souza
Bionic
Undecided
Unassigned
Cosmic
Undecided
Unassigned
Disco
Undecided
Unassigned

Bug Description

There is a new test cases added into fanotify09:
    457e13c (fanotify09: check merging of events on child subdir)

 tag=fanotify09 stime=1542775332
 cmdline="fanotify09"
 contacts=""
 analysis=exit
 <<>>
 tst_test.c:1085: INFO: Timeout per run is 0h 05m 00s
 fanotify09.c:161: INFO: Test #0: Events on children with both inode and mount marks
 fanotify09.c:150: PASS: group 0 got event: mask 2 pid=19769 fd=23 path=/tmp/ltp-2Jj8lWaBTL/UT3GCK/mntpoint/tfile_19769
 fanotify09.c:234: PASS: group 1 got no event
 fanotify09.c:234: PASS: group 2 got no event
 fanotify09.c:161: INFO: Test #1: Events on children and subdirs with both inode and mount marks
 fanotify09.c:150: PASS: group 0 got event: mask 2 pid=19769 fd=23 path=/tmp/ltp-2Jj8lWaBTL/UT3GCK/mntpoint/tfile_19769
 fanotify09.c:150: PASS: group 0 got event: mask 10 pid=19769 fd=24 path=/tmp/ltp-2Jj8lWaBTL/UT3GCK/mntpoint/testdir
 fanotify09.c:202: FAIL: first group got more than 2 events (72 > 48)
 fanotify09.c:234: PASS: group 1 got no event
 fanotify09.c:234: PASS: group 2 got no event

 Summary:
 passed 7
 failed 1
 skipped 0
 warnings 0

ProblemType: Bug
DistroRelease: Ubuntu 18.04
Package: linux-image-4.15.0-42-generic 4.15.0-42.45
ProcVersionSignature: User Name 4.15.0-42.45-generic 4.15.18
Uname: Linux 4.15.0-42-generic x86_64
AlsaDevices:
 total 0
 crw-rw---- 1 root audio 116, 1 Nov 22 06:27 seq
 crw-rw---- 1 root audio 116, 33 Nov 22 06:27 timer
AplayDevices: Error: [Errno 2] No such file or directory: 'aplay': 'aplay'
ApportVersion: 2.20.9-0ubuntu7.5
Architecture: amd64
ArecordDevices: Error: [Errno 2] No such file or directory: 'arecord': 'arecord'
AudioDevicesInUse: Error: command ['fuser', '-v', '/dev/snd/seq', '/dev/snd/timer'] failed with exit code 1:
Date: Thu Nov 22 06:45:22 2018
IwConfig: Error: [Errno 2] No such file or directory: 'iwconfig': 'iwconfig'
MachineType: Dell Inc. PowerEdge R320
PciMultimedia:

ProcFB: 0 mgadrmfb
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-4.15.0-42-generic root=UUID=7e417b15-9c42-401c-b706-06eb693e6d19 ro console=ttyS0,115200n8
RelatedPackageVersions:
 linux-restricted-modules-4.15.0-42-generic N/A
 linux-backports-modules-4.15.0-42-generic N/A
 linux-firmware 1.173.2
RfKill: Error: [Errno 2] No such file or directory: 'rfkill': 'rfkill'
SourcePackage: linux
UpgradeStatus: No upgrade log present (probably fresh install)
dmi.bios.date: 05/11/2012
dmi.bios.vendor: Dell Inc.
dmi.bios.version: 1.2.4
dmi.board.name: 0DY523
dmi.board.vendor: Dell Inc.
dmi.board.version: A03
dmi.chassis.type: 23
dmi.chassis.vendor: Dell Inc.
dmi.modalias: dmi:bvnDellInc.:bvr1.2.4:bd05/11/2012:svnDellInc.:pnPowerEdgeR320:pvr:rvnDellInc.:rn0DY523:rvrA03:cvnDellInc.:ct23:cvr:
dmi.product.name: PowerEdge R320
dmi.sys.vendor: Dell Inc.

Po-Hsu Lin (cypressyew) wrote :

This change was made by a bot.

Changed in linux (Ubuntu):
status: New → Confirmed

Could be found on Disco as well.

summary: - fanotify09 in LTP failed with Bionic
+ fanotify09 in LTP failed with first group got more than 2 events
Po-Hsu Lin (cypressyew) wrote :

For the commit mentioned in this test:
   Test case #2 is a regression test for commit b469e7e47c8a

To get this into Bionic kernel, two other cherry-picks are needed:
  1. 837a3934 (fanotify: generalize fanotify_should_send_event())
  2. 60f7ed8c (fsnotify: send path type events to group with super block marks)
  and finally b469e7e47c8a

To get this into Cosmic and Disco:
  1. 60f7ed8c (fsnotify: send path type events to group with super block marks)
  and finally b469e7e47c8a

Po-Hsu Lin (cypressyew) wrote :

Fix landed in Disco.

Changed in linux (Ubuntu Disco):
status: New → Fix Released
Po-Hsu Lin (cypressyew) on 2019-06-24
tags: added: linux-kvm sru-20190603 ubuntu-ltp-syscalls
Po-Hsu Lin (cypressyew) on 2019-07-10
tags: added: xenial
summary: - fanotify09 in LTP failed with first group got more than 2 events
+ fanotify09 test case 1 in LTP failed with first group got more than 2
+ events
Brad Figg (brad-figg) on 2019-07-24
tags: added: ubuntu-certified
Po-Hsu Lin (cypressyew) wrote :

Cosmic EOL.

Changed in linux (Ubuntu Cosmic):
status: New → Won't Fix
Po-Hsu Lin (cypressyew) on 2019-08-05
tags: added: sru-20190722
Po-Hsu Lin (cypressyew) wrote :

Passed on T-4.15 Azure

Po-Hsu Lin (cypressyew) wrote :

Passed on X-4.15 Azure

Po-Hsu Lin (cypressyew) wrote :
Changed in linux (Ubuntu Bionic):
status: New → Fix Released
Changed in ubuntu-kernel-tests:
status: New → In Progress
Changed in linux (Ubuntu):
status: Confirmed → Fix Released
Changed in linux (Ubuntu Xenial):
status: New → In Progress
Changed in ubuntu-kernel-tests:
assignee: nobody → Kleber Sacilotto de Souza (kleber-souza)
Changed in linux (Ubuntu Xenial):
assignee: nobody → Kleber Sacilotto de Souza (kleber-souza)

Test case #2 was added to fanotify09 as a regression test for the following upstream commit:

    b469e7e47c8a fanotify: fix handling of events on child sub-directory

which has been applied to v4.20 and backported to linux-4.19.y upstream stable. We backported these changes from 4.19.y to 4.15 but they are not trivial for backporting to older kernels, so the best option to fix the test case failures with 4.4 and older kernels is to apply a patch to revert the changes for this test case.

Test case patch sent to mailing-list:

https://lists.ubuntu.com/archives/kernel-team/2019-September/103837.html

Also marking the task for Xenial as 'Won't fix'.

Changed in linux (Ubuntu Xenial):
status: In Progress → Won't Fix
Sean Feole (sfeole) on 2019-09-25
tags: added: gcp
tags: added: sru-20190902

Reverting the changes, as I mentioned on comment #11, is not the best way to tackle it. I am working on a better solution.

Changed in ubuntu-kernel-tests:
status: In Progress → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers